from tritetmesh.tetmesh import PLCEditor, rectangle_collar
from numpy import *

dx = 10
R  = 3

ds = 0.20
dphi    = 2*pi/ceil(2*pi*R/ds)
phi_vec = arange(0, 2*pi, dphi, 'd')
sin_phi = sin(phi_vec)
cos_phi = cos(phi_vec)
N_circ  = len(phi_vec)

xvec = [0, dx, dx, 0]*4 + [2*dx, 3*dx, 3*dx, 2*dx]*4 
yvec = [0, 0, dx, dx]*4 + [0, 0, dx, dx]*4 
zvec = [0]*4 + [dx]*4 + [2*dx]*4 + [3*dx]*4 + [0]*4 + [dx]*4 + [2*dx]*4 + [3*dx]*4

second_struct = len(xvec)/2
channel_start = len(xvec)

print len(xvec), len(yvec), len(zvec)

xvec += (cos_phi*R+dx/2).tolist()*2 + (cos_phi*R+dx*2.5).tolist()*2 + [dx]*N_circ + [2*dx]*N_circ + [dx]*N_circ + [2*dx]*N_circ
yvec += (sin_phi*R+dx/2).tolist()*2 + (sin_phi*R+dx/2).tolist()*2 + (cos_phi*R+dx/2).tolist()*2 + (cos_phi*R+dx/2).tolist()*2
zvec += [dx]*N_circ + [2*dx]*N_circ + [dx]*N_circ + [2*dx]*N_circ + (sin_phi*R+dx/2).tolist()*2 + (sin_phi*R+dx*2.5).tolist()*2

print N_circ*6

print len(xvec), len(yvec), len(zvec)


# Register the vertices
editor = PLCEditor()
editor.register_vertices(xvec, yvec, zvec)

## Create the PLC editor and start adding faces
bottom_face = array([0, 1, 2, 3])
bottom_face2 = array([0, 1, 2, 3]) + second_struct

for i in range(0, 4):
    editor.add_facet(bottom_face + i*4, 1 if i < 2 else 2)
    if i in [1, 2]:
        editor.add_polygon_to_facet(range(channel_start+(i-1)*N_circ, channel_start+i*N_circ), editor.num_facets()-1, True)
        editor.add_facet(range(channel_start+(i-1)*N_circ, channel_start+i*N_circ), i*10, 0.1)

for i in range(0, 4):
    editor.add_facet(bottom_face2 + i*4, 3 if i < 2 else 4)
    if i in [1, 2]:
        editor.add_polygon_to_facet(range(channel_start+(i+1)*N_circ, channel_start+(i+2)*N_circ), editor.num_facets()-1, True)
        editor.add_facet(range(channel_start+(i+1)*N_circ, channel_start+(i+2)*N_circ), (i+2)*10, 0.1)
    

for i, face in enumerate(rectangle_collar(4)):
    editor.add_facet(face, 1)
    if i == 1:
        editor.add_polygon_to_facet(range(channel_start+4*N_circ, channel_start+5*N_circ), editor.num_facets()-1, True)
        editor.add_facet(range(channel_start+4*N_circ, channel_start+5*N_circ), 50, 0.1)
        
for i, face in enumerate(rectangle_collar(4, 8)):
    editor.add_facet(face, 2)
    if i == 1:
        editor.add_polygon_to_facet(range(channel_start+6*N_circ, channel_start+7*N_circ), editor.num_facets()-1, True)
        editor.add_facet(range(channel_start+6*N_circ, channel_start+7*N_circ), 70, 0.1)
        

for i, face in enumerate(rectangle_collar(4, 16)):
    editor.add_facet(face, 3)
    if i==3:
        editor.add_polygon_to_facet(range(channel_start+5*N_circ, channel_start+6*N_circ), editor.num_facets()-1, True)
        editor.add_facet(range(channel_start+5*N_circ, channel_start+6*N_circ), 60, 0.1)

for i, face in enumerate(rectangle_collar(4, 24)):
    editor.add_facet(face, 4)
    if i==3:
        editor.add_polygon_to_facet(range(channel_start+7*N_circ, channel_start+8*N_circ), editor.num_facets()-1, True)
        editor.add_facet(range(channel_start+7*N_circ, channel_start+8*N_circ), 80, 0.1)

editor.add_region([dx/2]*3, 2)
editor.add_region([dx/2]*2 + [dx*2.5], 3)
editor.add_region([dx*2.5] + [dx/2]*2, 4)
editor.add_region([dx*2.5] + [dx/2] + [dx*2.5], 5)
   
# Save the PLC
editor.save_plc("mesh/channel-plc")

# Create mesh
editor.build("mesh/channel-4-mesh", True)
