from tritetmesh.tetmesh import PLCEditor, rectangle_collar
from numpy import *

dx = 10
dx1 = 0.5
R  = 3

ds = 0.20
dphi    = 2*pi/ceil(2*pi*R/ds)
phi_vec = arange(0,2*pi, dphi, 'd')
sin_phi = sin(phi_vec)
cos_phi = cos(phi_vec)
N_circ  = len(phi_vec)

xvec = [0, dx, dx, 0]*3 + (cos_phi*R+dx/2).tolist()
yvec = [0, 0, dx, dx]*3 + (sin_phi*R+dx/2).tolist()
zvec = [0]*4 + [dx1]*4 + [dx]*4 + [dx]*N_circ

# Register the vertices
editor = PLCEditor()
editor.register_vertices(xvec, yvec, zvec)

print len(xvec)

# Create the PLC editor and start adding faces
bottom_face = array([0, 1, 2, 3])
for i in range(0, 3):
    max_area = 0.25 if i == 0 else -1
    editor.add_facet(bottom_face + i*4, 1 if i < 3 else 2, max_area)
    if i in [2, 3]:
        j = i-1
        editor.add_polygon_to_facet(range(12+(j-1)*N_circ, 12+j*N_circ), \
                                    editor.num_facets()-1, True)
        editor.add_facet(range(12+(j-1)*N_circ, 12+j*N_circ), j*10, 0.1)

for face in rectangle_collar(4):
    editor.add_facet(face, 1)

for face in rectangle_collar(4, 4):
    editor.add_facet(face, 1)

editor.add_region([dx/2]*3, 2, 0.05)
editor.add_region([dx/2]*2+[dx1/2], 2, 0.05)

# Save the PLC
editor.save_plc("channel-0-plc")

# Create mesh
editor.build("channel-mesh-0", True)
