#!/usr/bin/env python
# -*- coding: utf-8 -*-
__author__ = "Johan Hake (hake.dev@gmail.com)"
__copyright__ = "Copyright (C) 2010 " + __author__
__date__ = "2010-10-18 -- 2012-07-23"
__license__  = "GNU LGPL Version 3.0 or later"

# System imports
from distutils.core import setup
from os.path import join as pjoin
import glob

# Version number
major = 0
minor = 2

setup(name = "SubCell",
      version = "%d.%d" % (major, minor),
      description = """
      A declarative language describing subcellular dynamics.
      Also includes modules to run simulation based on the models.
      """,
      author = __author__.split("(")[0],
      author_email = __author__.split("(")[1][:-1],
      packages = ["subcell", "subcell.model", "subcell.common",
                  "subcell.backends", "subcell.runner"],
      package_dir = {"subcell": "src",
                     "subcell.model":pjoin("src","model"),
                     "subcell.common":pjoin("src","common"),
                     "subcell.runner":pjoin("src","runner"),
                     "subcell.backends":pjoin("src","backends"),})
