__author__ = "Johan Hake (hake.dev@gmail.com)"
__copyright__ = "Copyright (C) 2010 " + __author__
__date__ = "2011-04-25 -- 2011-08-29"
__license__  = "GNU LGPL Version 3.0 or later"

import re
import os
import hashlib
import numpy
import instant

# Import compile_extension_module
from dolfin.compilemodules.compilemodule import (compile_extension_module,
                                                 math_header)
from dolfin import has_openmp

__all__ = ["compile_reaction",]

def compile_reaction(code):
    # Autodetect classnames:

    # Complete the code
    code = math_header + \
"""
namespace dolfin
{
""" + code + \
"""
}
"""

    # Get headers
    headers = ["armadillo", "omp.h"] if has_openmp() else ["armadillo"]
    
    # Compile the extension module
    compiled_module = compile_extension_module(
        code, 
        additional_system_headers=headers,
        dolfin_module_import=["common", "la"])
    
    # Construct instances of the compiled subdomain classes
    return getattr(compiled_module, "ReactionNewtonSolver")


