__author__ = "Johan Hake (hake.dev@gmail.com)"
__copyright__ = "Copyright (C) 2010 " + __author__
__date__ = "2012-07-23 -- 2012-07-23"
__license__  = "GNU LGPL Version 3.0 or later"

__all__ = ["dolfin_version"]

# System imports
import dolfin
from distutils.version import LooseVersion, StrictVersion

# Check dolfin version
try:
    if StrictVersion(dolfin.__version__) == "1.0.0":
        dolfin_version = 1.0
    elif StrictVersion(dolfin.__version__) >= "1.0.0":
        dolfin_version = 1.1
    else:
        error("dolfin version is '%s' but it need to be 1.0 or higher.",
              dolfin_version)
except:
    if LooseVersion(dolfin.__version__) >= "1.0.0":
        dolfin_version = 1.1
    else:
        error("dolfin version is '%s' but it need to be 1.0 or higher.",
              dolfin_version)

